clang-tools 6.0.0

Public Member Functions | Protected Types | Protected Member Functions | Static Protected Attributes | List of all members
clang::tidy::modernize::MakeSmartPtrCheck Class Referenceabstract

Base class for MakeSharedCheck and MakeUniqueCheck. More...

`#include <MakeSmartPtrCheck.h>`

Inheritance diagram for clang::tidy::modernize::MakeSmartPtrCheck:
[legend]
Collaboration diagram for clang::tidy::modernize::MakeSmartPtrCheck:
[legend]

## Public Member Functions
| MakeSmartPtrCheck (StringRef Name, ClangTidyContext *Context, StringRef MakeSmartPtrFunctionName)
void | registerMatchers (ast_matchers::MatchFinder *Finder) final
| Override this to register AST matchers with `Finder`. More...
void | registerPPCallbacks (clang::CompilerInstance &Compiler) override
void | check (const ast_matchers::MatchFinder::MatchResult &Result) final
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Protected Types
using | SmartPtrTypeMatcher = ast_matchers::internal::BindableMatcher< QualType >

## Protected Member Functions
virtual SmartPtrTypeMatcher | getSmartPointerTypeMatcher () const =0
| Returns matcher that match with different smart pointer types. More...
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...

## Static Protected Attributes
static const char | PointerType [] = "pointerType"
static const char | ConstructorCall [] = "constructorCall"
static const char | ResetCall [] = "resetCall"
static const char | NewExpression [] = "newExpression"

## Additional Inherited Members
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Base class for MakeSharedCheck and MakeUniqueCheck.

Definition at line 25 of file MakeSmartPtrCheck.h.

## Member Typedef Documentation

## ◆ SmartPtrTypeMatcher

using clang::tidy::modernize::MakeSmartPtrCheck::SmartPtrTypeMatcher = ast_matchers::internal::BindableMatcher<QualType>
| protected

Definition at line 35 of file MakeSmartPtrCheck.h.

## Constructor & Destructor Documentation

## ◆ MakeSmartPtrCheck()

clang::tidy::modernize::MakeSmartPtrCheck::MakeSmartPtrCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context,
|  | StringRef | MakeSmartPtrFunctionName
| ) |  |

Definition at line 45 of file MakeSmartPtrCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::modernize::MakeSmartPtrCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| final virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 104 of file MakeSmartPtrCheck.cpp.

References ConstructorCall, clang::tidy::ClangTidyCheck::diag(), clang::tidy::ClangTidyCheck::getLangOpts(), NewExpression, PointerType, and ResetCall.

## ◆ getSmartPointerTypeMatcher()

virtual SmartPtrTypeMatcher clang::tidy::modernize::MakeSmartPtrCheck::getSmartPointerTypeMatcher | ( |  | ) | const
| protected pure virtual

Returns matcher that match with different smart pointer types.

Requires to bind pointer type (qualType) with PointerType string declared in this class.

Implemented in clang::tidy::modernize::MakeSharedCheck, and clang::tidy::modernize::MakeUniqueCheck.

## ◆ registerMatchers()

void clang::tidy::modernize::MakeSmartPtrCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| final virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 72 of file MakeSmartPtrCheck.cpp.

## ◆ registerPPCallbacks()

void clang::tidy::modernize::MakeSmartPtrCheck::registerPPCallbacks | ( | clang::CompilerInstance & | Compiler | ) |
| override

Definition at line 64 of file MakeSmartPtrCheck.cpp.

References clang::tidy::ClangTidyCheck::getLangOpts().

## ◆ storeOptions()

void clang::tidy::modernize::MakeSmartPtrCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 57 of file MakeSmartPtrCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, and clang::tidy::OptionsView::store().

## Member Data Documentation

## ◆ ConstructorCall

const char clang::tidy::modernize::MakeSmartPtrCheck::ConstructorCall = "constructorCall"
| static protected

Definition at line 44 of file MakeSmartPtrCheck.h.

Referenced by check().

## ◆ NewExpression

const char clang::tidy::modernize::MakeSmartPtrCheck::NewExpression = "newExpression"
| static protected

Definition at line 46 of file MakeSmartPtrCheck.h.

Referenced by check().

## ◆ PointerType

const char clang::tidy::modernize::MakeSmartPtrCheck::PointerType = "pointerType"
| static protected

Definition at line 43 of file MakeSmartPtrCheck.h.

Referenced by check(), clang::tidy::modernize::MakeUniqueCheck::getSmartPointerTypeMatcher(), and clang::tidy::modernize::MakeSharedCheck::getSmartPointerTypeMatcher().

## ◆ ResetCall

const char clang::tidy::modernize::MakeSmartPtrCheck::ResetCall = "resetCall"
| static protected

Definition at line 45 of file MakeSmartPtrCheck.h.

Referenced by check().

The documentation for this class was generated from the following files:

- MakeSmartPtrCheck.h
- MakeSmartPtrCheck.cpp